#include <stdio.h>
#include <portab.h>
#include <stdlib.h>
#include <string.h>
#include <aes.h>
#include <ldg.h>
#include <xcontrol.h>
#include "ldgcpx.h"

typedef struct {
	int version;
	char path[128];
	int garbage, idle, cookfunc;
} CPX_INFOS;
	
/* Section .TEXT : sert de zone inscriptible
 * par Xcontrol pour les sauvegardes du CPX.
 * Le champ version sert d'indicateur pour savoir si
 * le CPX a dj t sauv */

CPX_INFOS conf = {0, "", 10, 100, 0};

/* Macros et headers
 */
 
#define DRAW3D 		0x0080
#define LEN_PATH	20	/* longueur du champs CNF_PATH */
#include  			"ldgcpx.rh"
#include 			"ldgcpx.rsh"	/* Orcs ou Rsc3 */

/* Dfinitions de types
 */

struct foobar {
	int dummy;
};

/* Stucture utilise par le gestionnaire LDG */

struct lib {
	char name[32];          	/* nom AES de la lib */
	LDG *ldg;               	/* adresse de la LDG */
	int *usedby;     			/* liste des clients */
} *listlib;

/* Variables globales
 */

int errno;	/* make the compiler happy */
LDG_INFOS*	ldg = NULL;
CPX_PARAMS*	params;
GRECT*		cpx_wind;
OBJECT*		dialog;
char 		cnf_path[128]; /* mmoire du champs CNF_PATH */

/* Protos fonctions
 */

int  Cconws( char *);	/* debug */
void set_form( OBJECT *tree, CPX_PARAMS *par);
void cpy_ldg( LDG_INFOS *, LDG_INFOS *);
void select_form( int);
int ldg_snd_msg(int frm, int to, int msg, int w3, int w4, int w5, int w6, int w7);

/*
 *	Init Cpx : premire fonction appele par Xcontrol
 */

CPX_INFO *cdecl init( CPX_PARAMS *par) {
	int cdecl cpx_call(GRECT *curr_wind);
	static CPX_INFO info = { cpx_call,
							 0l,0l,0l,0l,0l,0l,0l,0l,0l};
	
	/* debug */
	Cconws( "\33H\r\n\r\n");
	
	/* Au boot de Xcontrol */
	if ( par->booting ) {
		LDG_INFOS *cook;
		
		/* Le CPX installe ses rglages */
		if( (*par->find_cookie)( 'LDGM', (long*)&cook) 
			&& conf.version ) {
			strcpy( cook->path, conf.path);
			cook->garbage = conf.garbage;
			cook->idle = conf.idle;
			cook->flags = conf.cookfunc;
		}
		return (CPX_INFO*)1L;

	} else {
		/* Ouverture du CPX */

		params=par;
		
		if( !params->rsc_init ) {
			int i;
			
			/* On fixe le ressource */	
			for( i=0; i<NUM_OBS; (*params->objc_adjust)( rs_object, i++));
		}
		
		dialog=(OBJECT*)rs_trindex[CPXFORM];
		set_form( dialog, par);
		select_form( CONFIGURE);
		
		/* On retourne les fonctions vnements : le CPX est prt  s'ouvrir */
		return &info;
	}
}

/*
 * dessin d'un object avec le bon clippage
 */

void draw_object( OBJECT *tree, int object) {
	objc_draw( tree, object, MAX_DEPTH, cpx_wind->g_x,cpx_wind->g_y,cpx_wind->g_w,cpx_wind->g_h);
}

/*
 *	dessin du formulaire et mise  jour de sa position
 */

void draw_tree(OBJECT *tree, int root) {
	tree[0].ob_x = cpx_wind->g_x;
	tree[0].ob_y = cpx_wind->g_y;
	draw_object( tree, root);
}

/*
 * Mise  jour des formulaires
 */

void set_form( OBJECT *tree, CPX_PARAMS *par) {
	LDG_INFOS *cook;
	int type = 0;
	char *p;
	
	/* Formulaire CONFIGURE */

	tree[CNF_COOKFUNC].ob_state |= DISABLED;
	tree[CNF_COOKNAME].ob_state |= DISABLED;
	strcpy( tree[CNF_COOKFUNC].ob_spec.tedinfo->te_ptext, "no");

	if( (*par->find_cookie)( 'LDGM', (long*)&cook)) {
		itoa( cook->version, tree[CNF_VERSION].ob_spec.tedinfo->te_ptext, 16);
		strcpy( cnf_path, cook->path);
		strncpy( tree[CNF_PATH].ob_spec.tedinfo->te_ptext, cook->path, LEN_PATH);
		itoa( cook->garbage, tree[CNF_GARBAGE].ob_spec.tedinfo->te_ptext, 10);
		itoa( cook->idle, tree[CNF_IDLE].ob_spec.tedinfo->te_ptext, 10);
		if( cook->version >= 0x0200) {
			tree[CNF_COOKFUNC].ob_state &= ~DISABLED;
			tree[CNF_COOKNAME].ob_state &= ~DISABLED;
			if( conf.cookfunc)
				strcpy( tree[CNF_COOKFUNC].ob_spec.tedinfo->te_ptext, "yes");
		}

		type = 1;
	} else {
		if( shel_envrn( &p, "LDGPATH")) {
			type = 2;
			strcpy( cnf_path, p);
			strncpy( tree[CNF_PATH].ob_spec.tedinfo->te_ptext, p, LEN_PATH);
		}
		if( shel_envrn( &p, "LDG_GARBAGE")) {
			type = 2;
			strcpy( tree[CNF_GARBAGE].ob_spec.tedinfo->te_ptext, p);
		}		
		if( shel_envrn( &p, "LDG_IDLE")) {
			type = 2;
			strcpy( tree[CNF_IDLE].ob_spec.tedinfo->te_ptext, p);
		}		
	}
	if( type == 1)
		strcpy( tree[CNF_TYPE].ob_spec.tedinfo->te_ptext, "cookie ");
	else if( type == 2) {
		strcpy( tree[CNF_TYPE].ob_spec.tedinfo->te_ptext, "environ");		
		tree[CNF_VERSION].ob_flags |= HIDETREE;
	} else if( type == 0) {
		strcpy( tree[CNF_TYPE].ob_spec.tedinfo->te_ptext, "nothing");		
		tree[CNF_VERSION].ob_flags |= HIDETREE;
	}
	
}

/*
 *	Appliquer les rglages du formulaire 
 *	(valable en fait que pour le cookie)
 */

void get_form( OBJECT *tree, CPX_PARAMS *par) {
	LDG_INFOS *cook;

	if( (*par->find_cookie)( 'LDGM', (long*)&cook)) {	
		strcpy( cook->path, cnf_path);
		cook->garbage = atoi(tree[CNF_GARBAGE].ob_spec.tedinfo->te_ptext);
		cook->idle = atoi(tree[CNF_IDLE].ob_spec.tedinfo->te_ptext);
		cook->flags = conf.cookfunc;
	}
	/* Pour la sauvegarde du CPX */
	strcpy( conf.path, cnf_path);
	conf.garbage  = atoi(tree[CNF_GARBAGE].ob_spec.tedinfo->te_ptext);
	conf.idle  = atoi(tree[CNF_IDLE].ob_spec.tedinfo->te_ptext);
}

/*
 * sous fonctions de cpx_call
 */

/* Appel du menu popup MENU */

char *mainMENU[] = { "  Configure    F1 ",
					 "  Manager      F2 ",
					 "  Library      F3 ",
					 "  Information  F4 " };

int call_menu( int button, int *lastform, GRECT *work) {
	int res, item;
	GRECT pop;
	
	switch( *lastform) {
	case CONFIGURE:
		item = 0;
		break;
	case MANAGER:
		item = 1;
		break;
	case LIBRARY:
		item = 2;
		break;
	case INFORMATION:
		item = 3;
		break;
	}
	objc_offset( dialog, button, &pop.g_x, &pop.g_y);
	pop.g_w = dialog[button].ob_width;
	pop.g_h = dialog[button].ob_height;
	res = (*params->do_pulldown)( mainMENU, 4, item, LARGE, &pop, work);
	switch( res ) {
	case 0:
		*lastform = CONFIGURE;
		break;
	case 1:
		*lastform = MANAGER;
		break;
	case 2:
		*lastform = LIBRARY;
		break;
	case 3:
		*lastform = INFORMATION;
		break;
	}
	return res;
}

/* Choix du formulaire */

void select_form( int form) {
	dialog[CONFIGURE].ob_flags 		|= HIDETREE;
	dialog[MANAGER].ob_flags 		|= HIDETREE;
	dialog[LIBRARY].ob_flags 		|= HIDETREE;
	dialog[INFORMATION].ob_flags 	|= HIDETREE;
	dialog[form].ob_flags 			&= ~HIDETREE;	
	dialog->ob_width = dialog[form].ob_width;
	dialog->ob_height = dialog[form].ob_height;
	dialog[form].ob_x = 0;
	dialog[form].ob_y = 0;
	if( form == MANAGER) {
		int request = appl_find( "LDGMGR  ");
		
		if( _GemParBlk.global[1] != 1 && request == -1
			/* && form_alert( 2, rs_frstr[ALRT_MGR]) == 2 */ ) {
			char path[200];

			strcpy( dialog[MGR_TITLE].ob_spec.tedinfo->te_ptext, rs_frstr[STR1]);
			draw_object( dialog, MGR_TITLE);
			strcpy( path, cnf_path);
			strcat( path, "\\ldgmgr.app");
			request = shel_write( 1, 1, 100, path, "");
			if( request == -1) {
				strcpy( path, "ldgmgr.app");
				if( shel_find( path) != -1)
					request = shel_write( 1, 1, 100, path, "");
			}
			evnt_timer( 500, 0);
		}
		/* Requte infos */
		if( request != -1) {
			int i, nlib=0;
			int buf[8];
			
			strcpy( dialog[MGR_TITLE].ob_spec.tedinfo->te_ptext, rs_frstr[STR2]);
			draw_object( dialog, MGR_TITLE);
			printf( "%d %d\n", _GemParBlk.global[2], request);

			ldg_snd_msg( 2 /*_GemParBlk.global[2]*/, request, LDG_LIST, 0,0,0,0,0);

/*			evnt_timer( 500, 0);
			i=0;
			/* Attente de la rponse */
			do {
				evnt_mesag( buf);
				i++;
			} while( buf[0] != LDG_LIST && i < 20);

			strcpy( dialog[MGR_TITLE].ob_spec.tedinfo->te_ptext, rs_frstr[STR3]);
			itoa( buf[7], dialog[MGR_VERSION].ob_spec.tedinfo->te_ptext, 16);
			itoa( buf[6], dialog[MGR_MAXAPP].ob_spec.tedinfo->te_ptext, 10);
			itoa( buf[7], dialog[MGR_MAXLIB].ob_spec.tedinfo->te_ptext, 10);
			listlib = *(struct lib**) &buf[3];
			for(i=0;i<buf[5];i++) if( listlib[i].ldg) nlib ++;
			itoa( nlib, dialog[MGR_NLIB].ob_spec.tedinfo->te_ptext, 10);
*/
			draw_object( dialog, MGR_TITLE);
		}
	}
}

char *actionMENU[]={ "  Garbage collector",
					 "  Force libs unloaded ",
					 "  List libs loaded"};

int call_action( int button, GRECT *work) {
	GRECT pop;
	
	objc_offset( dialog, button, &pop.g_x, &pop.g_y);
	pop.g_w = dialog[button].ob_width;
	pop.g_h = dialog[button].ob_height;
	return (*params->do_pulldown)( actionMENU, 3, -1, LARGE, &pop, work);
}

char *yesnoMENU[]= { "  no ",
					 "  yes " };

int call_yesno( int button, int def, GRECT *work) {
	GRECT pop;
	
	objc_offset( dialog, button, &pop.g_x, &pop.g_y);
	pop.g_w = dialog[button].ob_width;
	pop.g_h = dialog[button].ob_height;
	return (*params->do_pulldown)( yesnoMENU, 2, def, LARGE, &pop, work);
}


/*  Lorsque le CPX est ouvert dans Xcontrol,
 *  ce dernier appelle cette fonction.
 */

int cdecl cpx_call(GRECT *curr_wind) {
	int msg_buff[8],button,quit=0;
	int currform = CONFIGURE, res;
	static char path[128];
	char name[20], *p;

	/* Taille et coordonnes de la fentre CPX */
	cpx_wind=curr_wind; 
	
	/* On met  jour le formulaire */
/*	draw_tree( dialog, CONFIGURE); */
	
	do {
		button=(*params->do_form)( dialog, -1, msg_buff);

		if( button>=0 ) button &= 0x7FFF;

		/* dslection du bouton */
		dialog[button].ob_state &= ~SELECTED;

		switch( button) {
		/* Les boutons GLOBAUX */

		case CNF_OK:
		case LIB_OK:
		case INF_OK:
		case MGR_OK:
			/* Valider les rglages et quitter */
			get_form( dialog, params);
			quit = 1;
			break;
		case CNF_SAVE:
		case LIB_SAVE:
		case INF_SAVE:
		case MGR_SAVE:
			/* Valider les rglages et sauver */
			if( (*params->alert)(0) ) {
				get_form( dialog, params);
				conf.version = 1;
				(*params->write_config)( &conf, sizeof( CPX_INFOS));
			}
			draw_object(dialog, button);
			break;
		case CNF_CANCEL:
		case LIB_CANCEL:
		case INF_CANCEL:
		case MGR_CANCEL:
			/* Juste quitter sans valider */
			quit = 1;
			break;
		
		case CNF_MENU:
		case LIB_MENU:
		case INF_MENU:
		case MGR_MENU:
			/* Appel du popup MENU & affichage du formulaire */
			res = call_menu( button, &currform, curr_wind);
			if( res != -1) {
				select_form( currform);
				draw_tree( dialog, currform);
			} else
				draw_object(dialog, button);
			break;

		/* Formulaire CONFIGURE */
		
		/* Appel du slecteur de fichier */
		case CNF_PATH:
			*name = '\0';
			strcpy( path, conf.path);
			strcat( path, "*.*");
			if (fsel_input( path, name, &res) && res) {
				p = strrchr( path, '\\');
				if( p) *(p+1) = '\0';
				strcpy( conf.path, path);
				strncpy( dialog[CNF_PATH].ob_spec.tedinfo->te_ptext, path, LEN_PATH);
			}
			dialog[CNF_PATH].ob_state &= ~SELECTED;
			draw_object(dialog, CNF_PATH);
			break;
		case CNF_COOKFUNC:
			res = call_yesno( button, conf.cookfunc, curr_wind);
			if( res != -1) {
				conf.cookfunc = res;
				strcpy( dialog[CNF_COOKFUNC].ob_spec.tedinfo->te_ptext, res?"yes":"no");
			}
			draw_object( dialog, button);
			break;
			
		/* Formulaire MANAGER */

		case MGR_ACTION:
			switch( call_action( button, curr_wind)) {
			case 0:
				break;
			case 1:
				break;
			}
			draw_object( dialog, button);
			break;
			
		/* Autres vnements */
		default:
			if ( button == -1 ) {		
				/* Event-Message */
				switch ( msg_buff[0] ) {
		  		case WM_CLOSED:
					quit=1;
		 	 		break;
		  		case AC_CLOSE:
					quit=1;
		 	 		break;
		 	 	case LDG_LIST:
		 	 		form_alert( 1, "[1][LDG_LIST][OK]");
		 	 		break;
		 	 	case CT_KEY:
#define K_F1	0x3B00
#define K_F2	0x3C00
#define K_F3	0x3D00
#define K_F4	0x3E00

		 	 		switch(  msg_buff[3] ) {
		 	 		case K_F1:
		 	 			currform = CONFIGURE;
		 	 			select_form( CONFIGURE);
						draw_tree( dialog, currform);
		 	 			break;
		 	 		case K_F2:
		 	 			currform = MANAGER;
			 	 		select_form( MANAGER);
						draw_tree( dialog, currform);
		 	 			break;
		 	 		case K_F3:
		 	 			currform = LIBRARY;
				 	 	select_form( LIBRARY);
						draw_tree( dialog, currform);
		 	 			break;
		 	 		case K_F4:
		 	 			currform = INFORMATION;
						select_form( INFORMATION);
						draw_tree( dialog, currform);
		 	 			break;
		 	 		}
		 	 		break;
				}
			} else {				/* funktions-button aktiviert */
				;
			}
		}
	} while ( !quit );
	return 0;
}
