/*
 * MEM.LDG by Dominique Brziat
 * All rights reserved (c) 2003
 *
 * Binding MEM.LDG
 * $Id$
 */

#include <gem.h>
#ifdef __PUREC__
# include <ldg\mem.h>
#else
/* # include <mgem.h> */
# include <ldg/mem.h>
#endif
#include <stdio.h>

void* __CDECL (*_ldg_malloc)          ( long size, long context);
void* __CDECL (*_ldg_calloc)          ( long num, long size, long context);
void* __CDECL (*_ldg_realloc)         ( void *adr, long size, long context);
void  __CDECL (*_ldg_free)            ( void* addr, long context);
void  __CDECL (*_ldg_mallocczero)     ( long yes, long context);
void  __CDECL (*_ldg_mallocChunkSize) ( long size, long context);
char* __CDECL (*_ldg_strdup)          ( char *src, long context);
char* __CDECL (*_ldg_allocmode)       ( long mode, long context);

int ldg_mem_init( char *lib, int vers, LDG **mem) {
  *mem = ldg_open( lib, ldg_global);

  if( *mem == NULL) return ldg_error();
  if( (*mem)->vers < vers) return -100;
  _ldg_calloc          = ldg_find( "ldg_calloc", *mem);
  _ldg_free            = ldg_find( "ldg_free", *mem);
  _ldg_mallocczero     = ldg_find( "ldg_mallocczero", *mem);
  _ldg_mallocChunkSize = ldg_find( "ldg_mallocChunkSize", *mem);
  _ldg_malloc          = ldg_find( "ldg_malloc", *mem);
  _ldg_realloc         = ldg_find( "ldg_realloc", *mem);
  _ldg_strdup          = ldg_find( "ldg_strdup", *mem);
  _ldg_allocmode       = ldg_find( "ldg_allocmode", *mem);
  return ldg_error();
}

